/* $Id: Motorola.h,v 1.2 2007/01/15 21:45:18 olle Exp $
 *
 * Copyright (c) 2006, olle@toolcrypt.org
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without modification,
 * are permitted provided that the following conditions are met:
 *
 *    * Redistributions of source code must retain the above copyright notice,
 *      this list of conditions and the following disclaimer.
 *    * Redistributions in binary form must reproduce the above copyright notice,
 *      this list of conditions and the following disclaimer in the documentation
 *      and/or other materials provided with the distribution.
 *    * Neither the name of the <ORGANIZATION> nor the names of its contributors may
 *      be used to endorse or promote products derived from this software without 
 *      specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND 
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,DATA,
 * OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */

#include "GMSK.h"

class CMotorola
	: public CGMSKDemodulator
{
public:
	CMotorola(void* commandWnd, const long nSamplesPerSec, const long nBPS = 3600)
		: CGMSKDemodulator(nSamplesPerSec, nBPS)
		, cmdWnd(commandWnd)
		, currentsysid(0)
		, currentcc(0)
		, goodframes(1)
		, badframes(1)
		{
			memset(bitBuffer, 0, sizeof(bitBuffer));
		};
	~CMotorola () {};

	void handleBit(bool bit);

private:

	typedef struct codeWord_s
	{
		unsigned short id;
		bool grp;
		unsigned short cmd;
	} codeWord_t;
	codeWord_t codeWord[3];

	void processCodeWord(codeWord_t cwIn);
	void setSystemID(unsigned short id);

	void* cmdWnd;
    unsigned int bitBuffer[3];
	unsigned short currentsysid;
	unsigned short currentcc;
	unsigned int goodframes;
	unsigned int badframes;
	unsigned char synctimer;
};
