/* $Id: PrefDlg.cpp,v 1.3 2007/01/15 21:47:50 olle Exp $
 *
 * Copyright (c) 2007, olle@toolcrypt.org
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without modification,
 * are permitted provided that the following conditions are met:
 *
 *    * Redistributions of source code must retain the above copyright notice,
 *      this list of conditions and the following disclaimer.
 *    * Redistributions in binary form must reproduce the above copyright notice,
 *      this list of conditions and the following disclaimer in the documentation
 *      and/or other materials provided with the distribution.
 *    * Neither the name of the <ORGANIZATION> nor the names of its contributors may
 *      be used to endorse or promote products derived from this software without 
 *      specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND 
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,DATA,
 * OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */

#include "stdafx.h"
#include "PrefDlg.h"


// CPrefDlg dialog

CPrefDlg::CPrefDlg()
	: CDialog(CPrefDlg::IDD)
{
}

void CPrefDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_CHECK1, c_Mute);
	DDX_Control(pDX, IDC_CHECK2, c_FollowCalls);
	DDX_Control(pDX, IDC_CHECK3, c_ScanOnClear);
	DDX_Control(pDX, IDC_COMPORT, c_ComPort);
	DDX_Control(pDX, IDC_CHECK4, c_AutoAddIds);
	DDX_Control(pDX, IDC_EDIT1, c_MemoryLocation);
	DDX_Control(pDX, IDC_CHECK5, c_ControlBacklight);
	DDX_Control(pDX, IDC_RECEIVERTYPE, c_ReceiverType);
	DDX_Control(pDX, IDC_SAMPLERATE, c_SampleRate);
	DDX_Control(pDX, IDC_CHECK6, c_ReturnToCC);
}

BEGIN_MESSAGE_MAP(CPrefDlg, CDialog)
	ON_CBN_SELCHANGE(IDC_COMPORT, OnSelchangeComPort)
	ON_CBN_SELCHANGE(IDC_RECEIVERTYPE, OnSelchangeReceiverType)
	ON_CBN_SELCHANGE(IDC_SAMPLERATE, &CPrefDlg::OnCbnSelchangeSamplerate)
END_MESSAGE_MAP()


// CPrefDlg message handlers
void CPrefDlg::OnOK()
{
	// save app preferences
	char Path[MAX_PATH];
  	GetCurrentDirectory(MAX_PATH, Path);
	strcat(Path, "\\snabel.ini");

	char tmp[50];
	c_SampleRate.GetWindowTextA(tmp, 50);
	WritePrivateProfileString("audio", "samplerate", tmp, Path);

	if (c_Mute.GetCheck() == BST_CHECKED)
		WritePrivateProfileString("audio", "mute", "1", Path);
	else
		WritePrivateProfileString("audio", "mute", "0", Path);

	CString recvtype;
	recvtype.Format("%u", c_ReceiverType.GetCurSel());
	WritePrivateProfileString("tracking", "receiver_type", recvtype, Path);

	CString comport;
	comport.Format("%u", c_ComPort.GetCurSel());
	WritePrivateProfileString("tracking", "comport", comport, Path);

	c_MemoryLocation.GetLine(0, tmp, 5);
	WritePrivateProfileString("tracking", "memory", tmp, Path);

	if (c_FollowCalls.GetCheck() == BST_CHECKED)
		WritePrivateProfileString("tracking", "follow_calls", "1", Path);
	else
		WritePrivateProfileString("tracking", "follow_calls", "0", Path);

	if (c_ScanOnClear.GetCheck() == BST_CHECKED)
		WritePrivateProfileString("tracking", "scan_on_clear", "1", Path);
	else
		WritePrivateProfileString("tracking", "scan_on_clear", "0", Path);
	
	if (c_AutoAddIds.GetCheck() == BST_CHECKED)
		WritePrivateProfileString("tracking", "auto_add", "1", Path);
	else
		WritePrivateProfileString("tracking", "auto_add", "0", Path);
	
	if (c_ControlBacklight.GetCheck() == BST_CHECKED)
		WritePrivateProfileString("tracking", "backlight", "1", Path);
	else
		WritePrivateProfileString("tracking", "backlight", "0", Path);

	if (c_ReturnToCC.GetCheck() == BST_CHECKED)
		WritePrivateProfileString("tracking", "return_to_cc", "1", Path);
	else
		WritePrivateProfileString("tracking", "return_to_cc", "0", Path);
	
	CDialog::OnOK();
}

BOOL CPrefDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// initialize controls
	c_MemoryLocation.SetLimitText(4);

	// get app preferences
	char Path[MAX_PATH];
  	GetCurrentDirectory(MAX_PATH, Path);
	strcat(Path, "\\snabel.ini");

	switch(GetPrivateProfileInt("audio", "samplerate", 48000, Path))
	{
	case 10800:
		c_SampleRate.SetCurSel(8);
		break;
	case 11025:
		c_SampleRate.SetCurSel(7);
		break;
	case 12000:
		c_SampleRate.SetCurSel(6);
		break;
	case 21600:
		c_SampleRate.SetCurSel(5);
		break;
	case 22050:
		c_SampleRate.SetCurSel(4);
		break;
	case 24000:
		c_SampleRate.SetCurSel(3);
		break;
	case 36000:
		c_SampleRate.SetCurSel(2);
		break;
	case 44100:
		c_SampleRate.SetCurSel(1);
		break;
	case 48000:
	default:
		c_SampleRate.SetCurSel(0);
	}
    if (GetPrivateProfileInt("audio", "mute", 1, Path))
		c_Mute.SetCheck(BST_CHECKED);

	c_ReceiverType.SetCurSel(GetPrivateProfileInt("tracking", "receiver_type", 0, Path));
	c_ComPort.SetCurSel(GetPrivateProfileInt("tracking", "comport", 0, Path));
	char tmp[50];
	itoa(GetPrivateProfileInt("tracking", "memory", 0, Path), tmp, 10);
	SetDlgItemText(IDC_EDIT1, tmp);

	if (GetPrivateProfileInt("tracking", "follow_calls", 1, Path))
		c_FollowCalls.SetCheck(BST_CHECKED);
    if (GetPrivateProfileInt("tracking", "scan_on_clear", 0, Path))
		c_ScanOnClear.SetCheck(BST_CHECKED);
	if (GetPrivateProfileInt("tracking", "auto_add", 1, Path))
		c_AutoAddIds.SetCheck(BST_CHECKED);
	if (GetPrivateProfileInt("tracking", "backlight", 0, Path))
		c_ControlBacklight.SetCheck(BST_CHECKED);
	if (GetPrivateProfileInt("tracking", "return_to_cc", 0, Path))
		c_ReturnToCC.SetCheck(BST_CHECKED);

	return TRUE;  // return TRUE  unless you set the focus to a control
}


void CPrefDlg::OnSelchangeComPort()
{
}


void CPrefDlg::OnSelchangeReceiverType()
{
}
void CPrefDlg::OnCbnSelchangeSamplerate()
{
	// TODO: Add your control notification handler code here
}
