/* $Id: ReceiverCtrl.h,v 1.13 2007/02/04 11:35:26 olle Exp $
 *
 * Copyright (c) 2006, olle@toolcrypt.org
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without modification,
 * are permitted provided that the following conditions are met:
 *
 *    * Redistributions of source code must retain the above copyright notice,
 *      this list of conditions and the following disclaimer.
 *    * Redistributions in binary form must reproduce the above copyright notice,
 *      this list of conditions and the following disclaimer in the documentation
 *      and/or other materials provided with the distribution.
 *    * Neither the name of the <ORGANIZATION> nor the names of its contributors may
 *      be used to endorse or promote products derived from this software without 
 *      specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND 
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,DATA,
 * OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */


// Abstract Base Class to control a monitoring receiver

#pragma once

#include "Serial.h"

class CReceiverCtrl
{
public:
	CReceiverCtrl(UINT port = 0, UINT bps = 19200, UINT bits = 8, UINT parity = 0, UINT stopbits = 2);
	virtual ~CReceiverCtrl();

	virtual BOOL initReceiver() = 0;

	virtual void setFrequency(DOUBLE freq, BOOL narrow = FALSE) = 0;
	virtual DOUBLE getFrequency() = 0;
	virtual void setText(LPCSTR text) = 0;
	virtual void setText2(LPCSTR text) = 0;
	virtual void startScan() = 0;
	virtual BOOL isSquelchOpen() = 0;

	typedef enum { High, Low, Off } BacklightState;
	virtual void setBacklight(BacklightState state) = 0;

protected:
	CSerial m_port;
};