/* $Id: callinfo.h,v 1.5 2006/01/27 14:03:46 olle Exp $
 *
 * Copyright (c) 2006, olle@toolcrypt.org
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without modification,
 * are permitted provided that the following conditions are met:
 *
 *    * Redistributions of source code must retain the above copyright notice,
 *      this list of conditions and the following disclaimer.
 *    * Redistributions in binary form must reproduce the above copyright notice,
 *      this list of conditions and the following disclaimer in the documentation
 *      and/or other materials provided with the distribution.
 *    * Neither the name of the <ORGANIZATION> nor the names of its contributors may
 *      be used to endorse or promote products derived from this software without 
 *      specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND 
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,DATA,
 * OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */


// define data structures that describe a call and its components

#ifndef SNABEL_CALLINFO_H
#define SNABEL_CALLINFO_H

typedef struct snabel_addr_info_s
{
	UINT	system;
	UINT	fleet;
	UINT	addr;
} snabel_addr_info_t;

typedef enum snabel_call_type_enum
{
	SNABEL_CALL_TYPE_ANALOG_VOICE,
	SNABEL_CALL_TYPE_DIGITAL_VOICE,
	SNABEL_CALL_TYPE_DATA_STREAM,
	SNABEL_CALL_TYPE_DATA_DGRAM,
	SNABEL_CALL_TYPE_PSTN_CALL
} snabel_call_type_t;

typedef struct snabel_call_info_s
{
	snabel_call_type_t	calltype;

	snabel_addr_info_t	calladdr;
	snabel_addr_info_t	fromaddr;

	UINT				ctrlchnl;
	UINT				callchnl;
} snabel_call_info_t;


#endif