/* $Id: cmdWndProt.h,v 1.5 2007/02/04 11:35:27 olle Exp $
 *
 * Copyright (c) 2006, olle@toolcrypt.org
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without modification,
 * are permitted provided that the following conditions are met:
 *
 *    * Redistributions of source code must retain the above copyright notice,
 *      this list of conditions and the following disclaimer.
 *    * Redistributions in binary form must reproduce the above copyright notice,
 *      this list of conditions and the following disclaimer in the documentation
 *      and/or other materials provided with the distribution.
 *    * Neither the name of the <ORGANIZATION> nor the names of its contributors may
 *      be used to endorse or promote products derived from this software without 
 *      specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND 
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,DATA,
 * OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */


// command template
#define CMDWND_TEMPLATE(wnd, type, param)		(((CWnd *)(wnd))->PostMessage(WM_USER, type, (LPARAM)param))


// Add a line to the action log
#define	CMDWND_WPARAM_ADD_LOGSTR				0xf000
#define	CMDWND_ADD_LOGSTR(cmdWnd, str)			CMDWND_TEMPLATE(cmdWnd, CMDWND_WPARAM_ADD_LOGSTR, strdup(str))

// Report a call in progress
#define	CMDWND_WPARAM_REPORT_CALL				0xf001
#define	CMDWND_REPORT_CALL(cmdWnd, callinfo)	CMDWND_TEMPLATE(cmdWnd, CMDWND_WPARAM_REPORT_CALL, callinfo)

// Report cleardown of a call
#define	CMDWND_WPARAM_CLEAR_CALL				0xf002
#define	CMDWND_CLEAR_CALL(cmdWnd, callinfo)		CMDWND_TEMPLATE(cmdWnd, CMDWND_WPARAM_CLEAR_CALL, callinfo)

// Report found control channel sync
#define	CMDWND_WPARAM_GOT_SYNC					0xf003
#define	CMDWND_GOT_SYNC(cmdWnd)					CMDWND_TEMPLATE(cmdWnd, CMDWND_WPARAM_GOT_SYNC, 0)

// Report lost control channel sync
#define	CMDWND_WPARAM_LOST_SYNC					0xf004
#define	CMDWND_LOST_SYNC(cmdWnd)				CMDWND_TEMPLATE(cmdWnd, CMDWND_WPARAM_LOST_SYNC, 0)

// Report seen network address
#define	CMDWND_WPARAM_REPORT_ADDR				0xf005
#define	CMDWND_REPORT_ADDR(cmdWnd, sys)			CMDWND_TEMPLATE(cmdWnd, CMDWND_WPARAM_REPORT_ADDR, sys)

// User-initiated cleardown of current call
#define	CMDWND_WPARAM_CLEAR_CALL_MANUAL			0xf006
#define	CMDWND_CLEAR_CALL_MANUAL(cmdWnd)		CMDWND_TEMPLATE(cmdWnd, CMDWND_WPARAM_CLEAR_CALL_MANUAL, 0)

