/* $Id: nmt450.h,v 1.4 2007/01/11 16:57:04 olle Exp $
 *
 * Copyright (c) 2006, olle@toolcrypt.org
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without modification,
 * are permitted provided that the following conditions are met:
 *
 *    * Redistributions of source code must retain the above copyright notice,
 *      this list of conditions and the following disclaimer.
 *    * Redistributions in binary form must reproduce the above copyright notice,
 *      this list of conditions and the following disclaimer in the documentation
 *      and/or other materials provided with the distribution.
 *    * Neither the name of the <ORGANIZATION> nor the names of its contributors may
 *      be used to endorse or promote products derived from this software without 
 *      specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND 
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,DATA,
 * OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */


#ifndef NMT450_H
#define NMT450_H

#include "FSK.h"

class CNMT450
	: public CFSKDemodulator
{
public:
	CNMT450 (void* commandWnd, const long nSamplesPerSec, const long nBPS = 1200, unsigned short f0 = 1800, unsigned short f1 = 1200)
		: CFSKDemodulator(nSamplesPerSec, nBPS, f0, f1)
		, cmdWnd(commandWnd)
		, cnt(0)
		, synctimer(0)
		, currentchannel(0)
		, currentTA(0)
		, goodframes(1)
		, badframes(1)
		{
			memset(codeword, 0, sizeof(codeword));
		};
	~CNMT450 () {};

	void handleBit(bool bit);

private:

	void reportAddr(UINT prefix, UINT ident);
	BOOL getbit(int n, unsigned short *codewords);
	int simpleViterbi(unsigned short *sys, unsigned short *ecc, unsigned short *out);


	void* cmdWnd;
    unsigned int codeword[5];
	unsigned char cnt;
	unsigned short synctimer;
	unsigned short currentchannel;
	unsigned char currentTA;
	unsigned int goodframes;
	unsigned int badframes;

};

#define SYSTEM_NMT450 80000

#endif /* NMT450_H */
